from .download import downloading

downloading()

bl_info = {
    "name": "B4D Tools",
    "author": "Manellopgar",
    "description": "Tools for Motion Graphics",
    "blender": (4, 3, 0),
    "version": (1, 4, 2),
    "location": "Fix_Update_2024-11-28",
    "warning": "",
    "doc_url": "https://www.youtube.com/playlist?list=PL8iyOD866LeoeaJjQ1em5rrs_DjIc6-LI",
    "tracker_url": "",
    "category": "3D View",
}


import bpy
import bpy.utils.previews
import os
from . import translate


addon_keymaps = {}
_icons = None


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def find_areas_of_type(screen, area_type):
    areas = []
    for area in screen.areas:
        if area.type == area_type:
            areas.append(area)
    return areas


def find_area_by_type(screen, area_type, index):
    areas = find_areas_of_type(screen, area_type)
    if areas:
        return areas[index]
    return None


class SNA_AddonPreferences_C2E71(bpy.types.AddonPreferences):
    bl_idname = __package__

    def sna_ui_panels_enum_items(self, context):
        return [
            (
                "No Items",
                "No Items",
                "No generate enum items node found to create items!",
                "ERROR",
                0,
            )
        ]

    sna_ui_panels: bpy.props.EnumProperty(
        name="UI Panels",
        description="",
        items=[
            (
                "Use Addon Interface on T Panel",
                "Use Addon Interface on T Panel",
                "",
                0,
                0,
            ),
            (
                "Use Addon Interface on N Panel",
                "Use Addon Interface on N Panel",
                "",
                0,
                1,
            ),
        ],
    )

    def draw(self, context):
        if not (False):
            layout = self.layout
            layout.label(text="Choose Your Panel", icon_value=0)
            row_AD8CC = layout.row(heading="", align=False)
            row_AD8CC.alert = False
            row_AD8CC.enabled = True
            row_AD8CC.active = True
            row_AD8CC.use_property_split = False
            row_AD8CC.use_property_decorate = False
            row_AD8CC.scale_x = 1.0
            row_AD8CC.scale_y = 1.0
            row_AD8CC.alignment = "Expand".upper()
            row_AD8CC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_AD8CC.prop(
                bpy.context.preferences.addons[__package__].preferences,
                "sna_ui_panels",
                text=bpy.context.preferences.addons[
                    __package__
                ].preferences.sna_ui_panels,
                icon_value=0,
                emboss=True,
                expand=True,
            )


class SNA_PT_BCLONERS_F7E3F(bpy.types.Panel):
    bl_label = "BCloners"
    bl_idname = "SNA_PT_BCLONERS_F7E3F"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_context = ""
    bl_category = "B4D Tools"
    bl_order = 0
    bl_options = {"DEFAULT_CLOSED"}
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            not (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Grid Array",
            icon_value=296,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_GRID_ARRAY_Mode_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Linear",
            icon_value=92,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_LINEAR_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Radial",
            icon_value=304,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_RADIAL_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Honeycomb Array",
            icon_value=206,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_HONEYCOMB_ARRAY_Mode_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Object",
            icon_value=314,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_OBJECT_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Spline",
            icon_value=303,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_SPLINE_Mode_1_4_2".replace("_1_4_1", "_1_4_2")
        layout.separator(factor=0.5)
        layout.label(text="+ Tools", icon_value=0)
        op = layout.operator(
            "sna.operator_27876",
            text="BMograph Selection",
            icon_value=27,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_BMoGraph_Selection_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="BCloner to Matrix",
            icon_value=573,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_BCLONER_ToMatrix_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Matrix to Instances",
            icon_value=575,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_MATRIX_ToInstances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Realize Instances",
            icon_value=204,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_REALIZE_Instances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Split To Instances",
            icon_value=439,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_SPLIT_ToInstances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


class SNA_PT_MATERIAL_TOOLS_25CAB(bpy.types.Panel):
    bl_label = "Material Tools"
    bl_idname = "SNA_PT_MATERIAL_TOOLS_25CAB"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_context = ""
    bl_category = "B4D Tools"
    bl_order = 4
    bl_options = {"DEFAULT_CLOSED"}
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            not (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Global Material",
            icon_value=136,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_Global_MATERIAL_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Multishader",
            icon_value=756,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_MultiShader_MATSLOTS_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="MappingColor To Instances",
            icon_value=137,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_MappingColor_To_INSTANCES_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


class SNA_PT_EFFECTORS_77735(bpy.types.Panel):
    bl_label = "Effectors"
    bl_idname = "SNA_PT_EFFECTORS_77735"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_context = ""
    bl_category = "B4D Tools"
    bl_order = 1
    bl_options = {"DEFAULT_CLOSED"}
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            not (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator003_88223",
            text="Plain",
            icon_value=175,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_PLAIN_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Random",
            icon_value=356,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_RANDOM_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Step",
            icon_value=427,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_STEP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Target",
            icon_value=553,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_TARGET_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Delay",
            icon_value=445,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_DELAY_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="ImageTex",
            icon_value=476,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_IMAGE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="NoiseTex",
            icon_value=453,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_NOISE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator002_146a7",
            text="Sound",
            icon_value=273,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_SOUND_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Inheritance",
            icon_value=598,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_INHERITANCE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Spline",
            icon_value=348,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_SPLINE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Volume",
            icon_value=248,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_VOLUME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Time",
            icon_value=145,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_TIME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Formula",
            icon_value=642,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_FORMULA_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Push Apart",
            icon_value=590,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_PUSH_APART_1_4_1".replace("_1_4_1", "_1_4_2")


class SNA_OT_Operator001_F8E6E(bpy.types.Operator):
    bl_idname = "sna.operator001_f8e6e"
    bl_label = "Operator.001"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_group_name: bpy.props.StringProperty(
        name="Group Name", description="", default="", subtype="NONE", maxlen=0
    )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        if (
            property_exists("bpy.data.node_groups", globals(), locals())
            and self.sna_group_name in bpy.data.node_groups
        ):
            pass
        else:
            before_data = list(bpy.data.node_groups)
            bpy.ops.wm.append(
                directory=os.path.join(
                    os.path.dirname(__file__),
                    "assets",
                    "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                )
                + r"\NodeTree",
                filename=self.sna_group_name,
                link=False,
            )
            new_data = list(
                filter(lambda d: not d in before_data, list(bpy.data.node_groups))
            )
            appended_55C9B = None if not new_data else new_data[0]
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Desactiva el modificador activo
            obj.modifiers.active = None
        bpy.ops.object.modifier_add(type="NODES")
        name = None
        active_modifier = None
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Asignamos el modificador activo a la variable active_modifier
            active_modifier = obj.modifiers.active
            if active_modifier:
                name = active_modifier.name
            else:
                print("No existe Modificador activo.")
        else:
            print("El objeto seleccionado no tiene ningun modificador.")
        if active_modifier:
            bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                self.sna_group_name
            ]
            bpy.context.active_object.modifiers[name].name = (
                self.sna_group_name.replace("_1_4_2", "")
            )
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Desactiva el modificador activo
                obj.modifiers.active = None
            bpy.ops.object.modifier_add(type="NODES")
            name = None
            active_modifier = None
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Asignamos el modificador activo a la variable active_modifier
                active_modifier = obj.modifiers.active
                if active_modifier:
                    name = active_modifier.name
                else:
                    print("No existe Modificador activo.")
            else:
                print("El objeto seleccionado no tiene ningun modificador.")
            if active_modifier:
                bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                    "B4D_Object_CHANGE_FONT_Here_1_4_1".replace("_1_4_1", "_1_4_2")
                ]
                bpy.context.active_object.modifiers[name].name = (
                    "B4D_Object_CHANGE_FONT_Here_1_4_1".replace(
                        "_1_4_1", "_1_4_2"
                    ).replace("_1_4_2", "")
                )
                # print ("ejecuto de nuevo")
                # Creamos una variable para almacenar el nombre del modificador activo
                active_modifier = bpy.context.object.modifiers.active.name
                # Creamos una variable para almacenar el objeto seleccionado
                selected_obj = bpy.context.object
                # Comprobamos si el objecto esta seleccionado
                if selected_obj is not None:
                    # Comprobamos si el objeto tiene modificadores
                    if selected_obj.modifiers:
                        # Hacemos un loop para que lea todos los modificadores del objeto seleccionado
                        for index, modifier in enumerate(selected_obj.modifiers):
                            # Comparamos el nombre del modificador es el mismo que el del modificador activo
                            if modifier.name == active_modifier:
                                # print("Index of active modifier in the stack:", index)
                                # Creamos una variable para almacenar el indice del modificador activo
                                index_active_modifier = index
                                # Hacemos un break del loop para que no haga comprobaciones innecesarias
                                break
                        else:
                            print(
                                "Modifier" + active_modifier + "not found in the stack."
                            )
                    else:
                        print("Selected object has no modifiers.")
                else:
                    print("No object selected.")
                # print (index_active_modifier)
                # ahora que conocemos el indice del modificador activo, le decimos que lo mueva a la posición anterior.
                bpy.context.object.modifiers.move(index, index - 1)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator_27876(bpy.types.Operator):
    bl_idname = "sna.operator_27876"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_group_name: bpy.props.StringProperty(
        name="Group Name", description="", default="", subtype="NONE", maxlen=0
    )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        if (
            property_exists("bpy.data.node_groups", globals(), locals())
            and self.sna_group_name in bpy.data.node_groups
        ):
            pass
        else:
            before_data = list(bpy.data.node_groups)
            bpy.ops.wm.append(
                directory=os.path.join(
                    os.path.dirname(__file__),
                    "assets",
                    "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                )
                + r"\NodeTree",
                filename=self.sna_group_name,
                link=False,
            )
            new_data = list(
                filter(lambda d: not d in before_data, list(bpy.data.node_groups))
            )
            appended_93DE5 = None if not new_data else new_data[0]
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Desactiva el modificador activo
            obj.modifiers.active = None
        bpy.ops.object.modifier_add(type="NODES")
        name = None
        active_modifier = None
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Asignamos el modificador activo a la variable active_modifier
            active_modifier = obj.modifiers.active
            if active_modifier:
                name = active_modifier.name
            else:
                print("No existe Modificador activo.")
        else:
            print("El objeto seleccionado no tiene ningun modificador.")
        if active_modifier:
            bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                self.sna_group_name
            ]
            bpy.context.active_object.modifiers[name].name = (
                self.sna_group_name.replace("_1_4_2", "")
            )
            if "BFRACTURE" in self.sna_group_name.replace("_1_4_2", ""):
                # define context
                context = bpy.context
                # name of collection
                name = "BFracture Assets"
                # define context
                scene = context.scene
                coll = bpy.data.collections.get(name)
                # if it doesn't exist create it
                if coll is None:
                    coll = bpy.data.collections.new(name)
                # if it is not linked to scene collection trylink it
                if not scene.user_of_id(coll):
                    context.collection.children.link(coll)
            if "BTRACER" in self.sna_group_name.replace("_1_4_2", ""):
                # define context
                context = bpy.context
                # name of collection
                name = "Tracer Collection"
                # define context
                scene = context.scene
                coll = bpy.data.collections.get(name)
                # if it doesn't exist create it
                if coll is None:
                    coll = bpy.data.collections.new(name)
                # if it is not linked to scene collection trylink it
                if not scene.user_of_id(coll):
                    context.collection.children.link(coll)
            if "MATRIX_ToInstances" in self.sna_group_name.replace("_1_4_2", ""):
                # define context
                context = bpy.context
                # name of collection
                name = "Drop_Your_ASSETs_Here"
                # define context
                scene = context.scene
                coll = bpy.data.collections.get(name)
                # if it doesn't exist create it
                if coll is None:
                    coll = bpy.data.collections.new(name)
                # if it is not linked to scene collection trylink it
                if not scene.user_of_id(coll):
                    context.collection.children.link(coll)
            if "BEmitter" in self.sna_group_name.replace("_1_4_2", ""):
                # define context
                context = bpy.context
                # name of collection
                name = "BEmitter_Assets"
                # define context
                scene = context.scene
                coll = bpy.data.collections.get(name)
                # if it doesn't exist create it
                if coll is None:
                    coll = bpy.data.collections.new(name)
                # if it is not linked to scene collection trylink it
                if not scene.user_of_id(coll):
                    context.collection.children.link(coll)
            if "_BCloner_" in self.sna_group_name.replace("_1_4_2", ""):
                if (
                    property_exists("bpy.data.node_groups", globals(), locals())
                    and "B4D_BCloner_TRANSFORM_1_4_1".replace("_1_4_1", "_1_4_2")
                    in bpy.data.node_groups
                ):
                    pass
                else:
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(
                        directory=os.path.join(
                            os.path.dirname(__file__),
                            "assets",
                            "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                        )
                        + r"\NodeTree",
                        filename="B4D_BCloner_TRANSFORM_1_4_1".replace(
                            "_1_4_1", "_1_4_2"
                        ),
                        link=False,
                    )
                    new_data = list(
                        filter(
                            lambda d: not d in before_data, list(bpy.data.node_groups)
                        )
                    )
                    appended_6F4EB = None if not new_data else new_data[0]
                # Asignamos el objeto activo a la variable obj
                obj = bpy.context.active_object
                # Comprueba si el objeto seleccionado tiene modificadores
                if obj and obj.modifiers:
                    # Desactiva el modificador activo
                    obj.modifiers.active = None
                bpy.ops.object.modifier_add(type="NODES")
                name = None
                active_modifier = None
                # Asignamos el objeto activo a la variable obj
                obj = bpy.context.active_object
                # Comprueba si el objeto seleccionado tiene modificadores
                if obj and obj.modifiers:
                    # Asignamos el modificador activo a la variable active_modifier
                    active_modifier = obj.modifiers.active
                    if active_modifier:
                        name = active_modifier.name
                    else:
                        print("No existe Modificador activo.")
                else:
                    print("El objeto seleccionado no tiene ningun modificador.")
                if active_modifier:
                    bpy.context.object.modifiers[name].node_group = (
                        bpy.data.node_groups[
                            "B4D_BCloner_TRANSFORM_1_4_1".replace("_1_4_1", "_1_4_2")
                        ]
                    )
                    bpy.context.active_object.modifiers[name].name = (
                        "B4D_BCloner_TRANSFORM"
                    )
                    # define context
                    context = bpy.context
                    # name of collection
                    name = "Drop_Your_ASSETs_Here"
                    # define context
                    scene = context.scene
                    coll = bpy.data.collections.get(name)
                    # if it doesn't exist create it
                    if coll is None:
                        coll = bpy.data.collections.new(name)
                    # if it is not linked to scene collection trylink it
                    if not scene.user_of_id(coll):
                        context.collection.children.link(coll)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator002_146A7(bpy.types.Operator):
    bl_idname = "sna.operator002_146a7"
    bl_label = "Operator.002"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_group_name: bpy.props.StringProperty(
        name="Group Name", description="", default="", subtype="NONE", maxlen=0
    )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        if (
            property_exists("bpy.data.node_groups", globals(), locals())
            and self.sna_group_name in bpy.data.node_groups
        ):
            pass
        else:
            before_data = list(bpy.data.node_groups)
            bpy.ops.wm.append(
                directory=os.path.join(
                    os.path.dirname(__file__),
                    "assets",
                    "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                )
                + r"\NodeTree",
                filename=self.sna_group_name,
                link=False,
            )
            new_data = list(
                filter(lambda d: not d in before_data, list(bpy.data.node_groups))
            )
            appended_DFAA9 = None if not new_data else new_data[0]
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Desactiva el modificador activo
            obj.modifiers.active = None
        bpy.ops.object.modifier_add(type="NODES")
        name = None
        active_modifier = None
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Asignamos el modificador activo a la variable active_modifier
            active_modifier = obj.modifiers.active
            if active_modifier:
                name = active_modifier.name
            else:
                print("No existe Modificador activo.")
        else:
            print("El objeto seleccionado no tiene ningun modificador.")
        if active_modifier:
            bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                self.sna_group_name
            ]
            bpy.context.active_object.modifiers[name].name = (
                self.sna_group_name.replace("_1_4_2", "")
            )
            if (
                property_exists("bpy.data.node_groups", globals(), locals())
                and "B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2")
                in bpy.data.node_groups
            ):
                pass
            else:
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(
                    directory=os.path.join(
                        os.path.dirname(__file__),
                        "assets",
                        "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                    )
                    + r"\NodeTree",
                    filename="B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2"),
                    link=False,
                )
                new_data = list(
                    filter(lambda d: not d in before_data, list(bpy.data.node_groups))
                )
                appended_E5D51 = None if not new_data else new_data[0]
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Desactiva el modificador activo
                obj.modifiers.active = None
            bpy.ops.object.modifier_add(type="NODES")
            name = None
            active_modifier = None
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Asignamos el modificador activo a la variable active_modifier
                active_modifier = obj.modifiers.active
                if active_modifier:
                    name = active_modifier.name
                else:
                    print("No existe Modificador activo.")
            else:
                print("El objeto seleccionado no tiene ningun modificador.")
            if active_modifier:
                bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                    "B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2")
                ]
                bpy.context.active_object.modifiers[name].name = (
                    "B4D_Field_BASIC_FIELDS"
                )
                if "Effector" in self.sna_group_name.replace("_1_4_2", ""):
                    # define context
                    context = bpy.context
                    # name of collection
                    name = "Custom_Asset_Modify"
                    # define context
                    scene = context.scene
                    coll = bpy.data.collections.get(name)
                    # if it doesn't exist create it
                    if coll is None:
                        coll = bpy.data.collections.new(name)
                    # if it is not linked to scene collection trylink it
                    if not scene.user_of_id(coll):
                        context.collection.children.link(coll)
                    # Get the object named "Sound Baked"
                    obj = bpy.data.objects.get("Sound_Baked")
                    # If the object exists, insert a keyframe
                    if obj:
                        # Insert a keyframe for the object's position
                        obj.keyframe_insert(
                            data_path="location",
                            index=-1,
                            frame=bpy.context.scene.frame_current,
                        )
                        print("Keyframe added for object", obj.name)
                    else:
                        print("Object not found")
                    # Deselect all objects
                    bpy.ops.object.select_all(action="DESELECT")
                    if obj:
                        # Select the object named "Sound Baked"
                        obj.select_set(True)
                        print("Object selected:", obj.name)
                    else:
                        print("Object 'Sound Baked' not found")
                    # Get the current area type
                    area = bpy.context.area.type
                    # If the current area is not already the Graph Editor, switch to it
                    if area != "GRAPH_EDITOR":
                        bpy.context.area.type = "GRAPH_EDITOR"
                    # Get the Graph Editor space
                    graph_editor = bpy.context.space_data
                    # Deactivate "Only Show Selected" option
                    graph_editor.dopesheet.show_only_selected = False
                    area_13D0D = find_area_by_type(
                        bpy.context.screen, "GRAPH_EDITOR", 0
                    )
                    with bpy.context.temp_override(
                        area=area_13D0D,
                    ):
                        bpy.ops.graph.sound_to_samples(
                            "INVOKE_DEFAULT",
                        )
                        # print ("ejecuto de nuevo")
                        # Creamos una variable para almacenar el nombre del modificador activo
                        active_modifier = bpy.context.object.modifiers.active.name
                        # Creamos una variable para almacenar el objeto seleccionado
                        selected_obj = bpy.context.object
                        # Comprobamos si el objecto esta seleccionado
                        if selected_obj is not None:
                            # Comprobamos si el objeto tiene modificadores
                            if selected_obj.modifiers:
                                # Hacemos un loop para que lea todos los modificadores del objeto seleccionado
                                for index, modifier in enumerate(
                                    selected_obj.modifiers
                                ):
                                    # Comparamos el nombre del modificador es el mismo que el del modificador activo
                                    if modifier.name == active_modifier:
                                        # print("Index of active modifier in the stack:", index)
                                        # Creamos una variable para almacenar el indice del modificador activo
                                        index_active_modifier = index
                                        # Hacemos un break del loop para que no haga comprobaciones innecesarias
                                        break
                                else:
                                    print(
                                        "Modifier"
                                        + active_modifier
                                        + "not found in the stack."
                                    )
                            else:
                                print("Selected object has no modifiers.")
                        else:
                            print("No object selected.")
                        # print (index_active_modifier)
                        # ahora que conocemos el indice del modificador activo, le decimos que lo mueva a la posición anterior.
                        bpy.context.object.modifiers.move(index, index - 1)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_OBJECT_TOOLS_2D0E8(bpy.types.Panel):
    bl_label = "Object Tools"
    bl_idname = "SNA_PT_OBJECT_TOOLS_2D0E8"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_context = ""
    bl_category = "B4D Tools"
    bl_order = 3
    bl_options = {"DEFAULT_CLOSED"}
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            not (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="BFracture",
            icon_value=207,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BFRACTURE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator001_f8e6e",
            text="BMoText",
            icon_value=392,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BMoTEXT_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="BTracer",
            icon_value=194,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BTRACER_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="BEmitter",
            icon_value=659,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BEmitter_1_4_1".replace("_1_4_1", "_1_4_2")
        layout.separator(factor=0.5)
        layout.label(text="+Tools", icon_value=0)
        op = layout.operator(
            "sna.operator_27876",
            text="BTracer To Mesh",
            icon_value=280,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BTracerToMESH_1_4_1".replace("_1_4_1", "_1_4_2")


class SNA_OT_Operator003_88223(bpy.types.Operator):
    bl_idname = "sna.operator003_88223"
    bl_label = "Operator.003"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_group_name: bpy.props.StringProperty(
        name="Group Name", description="", default="", subtype="NONE", maxlen=0
    )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        if (
            property_exists("bpy.data.node_groups", globals(), locals())
            and self.sna_group_name in bpy.data.node_groups
        ):
            pass
        else:
            before_data = list(bpy.data.node_groups)
            bpy.ops.wm.append(
                directory=os.path.join(
                    os.path.dirname(__file__),
                    "assets",
                    "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                )
                + r"\NodeTree",
                filename=self.sna_group_name,
                link=False,
            )
            new_data = list(
                filter(lambda d: not d in before_data, list(bpy.data.node_groups))
            )
            appended_08578 = None if not new_data else new_data[0]
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Desactiva el modificador activo
            obj.modifiers.active = None
        bpy.ops.object.modifier_add(type="NODES")
        name = None
        active_modifier = None
        # Asignamos el objeto activo a la variable obj
        obj = bpy.context.active_object
        # Comprueba si el objeto seleccionado tiene modificadores
        if obj and obj.modifiers:
            # Asignamos el modificador activo a la variable active_modifier
            active_modifier = obj.modifiers.active
            if active_modifier:
                name = active_modifier.name
            else:
                print("No existe Modificador activo.")
        else:
            print("El objeto seleccionado no tiene ningun modificador.")
        if active_modifier:
            bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                self.sna_group_name
            ]
            bpy.context.active_object.modifiers[name].name = (
                self.sna_group_name.replace("_1_4_2", "")
            )
            if (
                property_exists("bpy.data.node_groups", globals(), locals())
                and "B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2")
                in bpy.data.node_groups
            ):
                pass
            else:
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(
                    directory=os.path.join(
                        os.path.dirname(__file__),
                        "assets",
                        "B4D_Tools_1_4_2_BClonersEffectors_AssetsAddon_Gumroad_Blender_4_1.blend",
                    )
                    + r"\NodeTree",
                    filename="B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2"),
                    link=False,
                )
                new_data = list(
                    filter(lambda d: not d in before_data, list(bpy.data.node_groups))
                )
                appended_05194 = None if not new_data else new_data[0]
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Desactiva el modificador activo
                obj.modifiers.active = None
            bpy.ops.object.modifier_add(type="NODES")
            name = None
            active_modifier = None
            # Asignamos el objeto activo a la variable obj
            obj = bpy.context.active_object
            # Comprueba si el objeto seleccionado tiene modificadores
            if obj and obj.modifiers:
                # Asignamos el modificador activo a la variable active_modifier
                active_modifier = obj.modifiers.active
                if active_modifier:
                    name = active_modifier.name
                else:
                    print("No existe Modificador activo.")
            else:
                print("El objeto seleccionado no tiene ningun modificador.")
            if active_modifier:
                bpy.context.object.modifiers[name].node_group = bpy.data.node_groups[
                    "B4D_Field_BASIC_FIELDS_1_4_1".replace("_1_4_1", "_1_4_2")
                ]
                bpy.context.active_object.modifiers[name].name = (
                    "B4D_Field_BASIC_FIELDS"
                )
                if "Effector" in self.sna_group_name:
                    # define context
                    context = bpy.context
                    # name of collection
                    name = "Custom_Asset_Modify"
                    # define context
                    scene = context.scene
                    coll = bpy.data.collections.get(name)
                    # if it doesn't exist create it
                    if coll is None:
                        coll = bpy.data.collections.new(name)
                    # if it is not linked to scene collection trylink it
                    if not scene.user_of_id(coll):
                        context.collection.children.link(coll)
                    # print ("ejecuto de nuevo")
                    # Creamos una variable para almacenar el nombre del modificador activo
                    active_modifier = bpy.context.object.modifiers.active.name
                    # Creamos una variable para almacenar el objeto seleccionado
                    selected_obj = bpy.context.object
                    # Comprobamos si el objecto esta seleccionado
                    if selected_obj is not None:
                        # Comprobamos si el objeto tiene modificadores
                        if selected_obj.modifiers:
                            # Hacemos un loop para que lea todos los modificadores del objeto seleccionado
                            for index, modifier in enumerate(selected_obj.modifiers):
                                # Comparamos el nombre del modificador es el mismo que el del modificador activo
                                if modifier.name == active_modifier:
                                    # print("Index of active modifier in the stack:", index)
                                    # Creamos una variable para almacenar el indice del modificador activo
                                    index_active_modifier = index
                                    # Hacemos un break del loop para que no haga comprobaciones innecesarias
                                    break
                            else:
                                print(
                                    "Modifier"
                                    + active_modifier
                                    + "not found in the stack."
                                )
                        else:
                            print("Selected object has no modifiers.")
                    else:
                        print("No object selected.")
                    # print (index_active_modifier)
                    # ahora que conocemos el indice del modificador activo, le decimos que lo mueva a la posición anterior.
                    bpy.context.object.modifiers.move(index, index - 1)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_FIELDS_DB01C(bpy.types.Panel):
    bl_label = "Fields"
    bl_idname = "SNA_PT_FIELDS_DB01C"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_context = ""
    bl_category = "B4D Tools"
    bl_order = 2
    bl_options = {"DEFAULT_CLOSED"}
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            not (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Random",
            icon_value=356,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_RANDOM_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Step",
            icon_value=427,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_STEP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Image Tex",
            icon_value=137,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_IMAGE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Formula",
            icon_value=642,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_FORMULA_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Sound",
            icon_value=251,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_SOUND_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Time",
            icon_value=145,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_TIME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Spline Object",
            icon_value=303,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_SPLINE_OBJECT_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Object Proximity",
            icon_value=551,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_OBJECT_Proximity_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        layout.separator(factor=0.5)
        layout.label(text="Modifier Fields", icon_value=110)
        op = layout.operator(
            "sna.operator_27876",
            text="Clamp",
            icon_value=363,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_CLAMP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="ColorRamp",
            icon_value=765,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_COLORRAMP_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Curve",
            icon_value=199,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_CURVE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Invert",
            icon_value=762,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_INVERT_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Map Range",
            icon_value=77,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_MAP_RANGE_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Quantize",
            icon_value=468,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_QUANTIZE_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


class SNA_PT_MATERIAL_TOOLS_C6AC7(bpy.types.Panel):
    bl_label = "Material Tools"
    bl_idname = "SNA_PT_MATERIAL_TOOLS_C6AC7"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    bl_context = ""
    bl_order = 4
    bl_options = {"DEFAULT_CLOSED"}
    bl_parent_id = "VIEW3D_PT_tools_active"
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Global Material",
            icon_value=136,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_Global_MATERIAL_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Multishader",
            icon_value=756,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_MultiShader_MATSLOTS_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="MappingColor To Instances",
            icon_value=137,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Set_MappingColor_To_INSTANCES_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


class SNA_PT_BCLONERS_2CFE5(bpy.types.Panel):
    bl_label = "BCloners"
    bl_idname = "SNA_PT_BCLONERS_2CFE5"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    bl_context = ""
    bl_order = 0
    bl_options = {"DEFAULT_CLOSED"}
    bl_parent_id = "VIEW3D_PT_tools_active"
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Grid Array",
            icon_value=296,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_GRID_ARRAY_Mode_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Linear",
            icon_value=92,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_LINEAR_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Radial",
            icon_value=304,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_RADIAL_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Honeycomb Array",
            icon_value=206,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_HONEYCOMB_ARRAY_Mode_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Object",
            icon_value=314,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_OBJECT_Mode_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Spline",
            icon_value=303,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_BCloner_SPLINE_Mode_1_4_2".replace("_1_4_1", "_1_4_2")
        layout.separator(factor=0.5)
        layout.label(text="+ Tools", icon_value=0)
        op = layout.operator(
            "sna.operator_27876",
            text="BMograph Selection",
            icon_value=27,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_BMoGraph_Selection_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="BCloner to Matrix",
            icon_value=573,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_BCLONER_ToMatrix_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Matrix to Instances",
            icon_value=575,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_MATRIX_ToInstances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Realize Instances",
            icon_value=204,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_REALIZE_Instances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Split To Instances",
            icon_value=439,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Tool_SPLIT_ToInstances_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


class SNA_PT_EFFECTORS_B0489(bpy.types.Panel):
    bl_label = "Effectors"
    bl_idname = "SNA_PT_EFFECTORS_B0489"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    bl_context = ""
    bl_order = 1
    bl_options = {"DEFAULT_CLOSED"}
    bl_parent_id = "VIEW3D_PT_tools_active"
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator003_88223",
            text="Plain",
            icon_value=175,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_PLAIN_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Random",
            icon_value=356,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_RANDOM_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Step",
            icon_value=427,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_STEP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Target",
            icon_value=553,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_TARGET_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Delay",
            icon_value=445,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_DELAY_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="ImageTex",
            icon_value=476,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_IMAGE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="NoiseTex",
            icon_value=453,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_NOISE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator002_146a7",
            text="Sound",
            icon_value=273,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_SOUND_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Inheritance",
            icon_value=598,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_INHERITANCE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Spline",
            icon_value=348,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_SPLINE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Volume",
            icon_value=248,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_VOLUME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Time",
            icon_value=145,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_TIME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Formula",
            icon_value=642,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_FORMULA_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator003_88223",
            text="Push Apart",
            icon_value=590,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Effector_PUSH_APART_1_4_1".replace("_1_4_1", "_1_4_2")


class SNA_PT_OBJECT_TOOLS_B0D35(bpy.types.Panel):
    bl_label = "Object Tools"
    bl_idname = "SNA_PT_OBJECT_TOOLS_B0D35"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    bl_context = ""
    bl_order = 3
    bl_options = {"DEFAULT_CLOSED"}
    bl_parent_id = "VIEW3D_PT_tools_active"
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="BFracture",
            icon_value=207,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BFRACTURE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator001_f8e6e",
            text="BMoText",
            icon_value=392,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BMoTEXT_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="BTracer",
            icon_value=229,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BTRACER_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="BEmitter",
            icon_value=659,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BEmitter_1_4_1".replace("_1_4_1", "_1_4_2")
        layout.separator(factor=0.5)
        layout.label(text="+Tools", icon_value=0)
        op = layout.operator(
            "sna.operator_27876",
            text="BTracer To Mesh",
            icon_value=280,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Object_BTracerToMESH_1_4_1".replace("_1_4_1", "_1_4_2")


class SNA_PT_FIELDS_4D6BE(bpy.types.Panel):
    bl_label = "Fields"
    bl_idname = "SNA_PT_FIELDS_4D6BE"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    bl_context = ""
    bl_order = 2
    bl_options = {"DEFAULT_CLOSED"}
    bl_parent_id = "VIEW3D_PT_tools_active"
    bl_ui_units_x = 0

    @classmethod
    def poll(cls, context):
        return not (
            (
                bpy.context.preferences.addons[__package__].preferences.sna_ui_panels
                == "Use Addon Interface on N Panel"
            )
        )

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator(
            "sna.operator_27876",
            text="Random",
            icon_value=356,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_RANDOM_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Step",
            icon_value=427,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_STEP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Image Tex",
            icon_value=137,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_IMAGE_Tex_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Formula",
            icon_value=642,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_FORMULA_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Sound",
            icon_value=251,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_SOUND_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Time",
            icon_value=145,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_TIME_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Spline Object",
            icon_value=303,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_SPLINE_OBJECT_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Object Proximity",
            icon_value=551,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Field_OBJECT_Proximity_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        layout.separator(factor=0.5)
        layout.label(text="Modifier Fields", icon_value=110)
        op = layout.operator(
            "sna.operator_27876",
            text="Clamp",
            icon_value=363,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_CLAMP_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="ColorRamp",
            icon_value=765,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_COLORRAMP_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Curve",
            icon_value=199,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_CURVE_1_4_1".replace("_1_4_1", "_1_4_2")
        op = layout.operator(
            "sna.operator_27876",
            text="Invert",
            icon_value=762,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_INVERT_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Map Range",
            icon_value=77,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_MAP_RANGE_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )
        op = layout.operator(
            "sna.operator_27876",
            text="Quantize",
            icon_value=468,
            emboss=True,
            depress=False,
        )
        op.sna_group_name = "B4D_Modifier_Field_QUANTIZE_1_4_1".replace(
            "_1_4_1", "_1_4_2"
        )


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_AddonPreferences_C2E71)
    bpy.utils.register_class(SNA_PT_BCLONERS_F7E3F)
    bpy.utils.register_class(SNA_PT_MATERIAL_TOOLS_25CAB)
    bpy.utils.register_class(SNA_PT_EFFECTORS_77735)
    bpy.utils.register_class(SNA_OT_Operator001_F8E6E)
    bpy.utils.register_class(SNA_OT_Operator_27876)
    bpy.utils.register_class(SNA_OT_Operator002_146A7)
    bpy.utils.register_class(SNA_PT_OBJECT_TOOLS_2D0E8)
    bpy.utils.register_class(SNA_OT_Operator003_88223)
    bpy.utils.register_class(SNA_PT_FIELDS_DB01C)
    bpy.utils.register_class(SNA_PT_MATERIAL_TOOLS_C6AC7)
    bpy.utils.register_class(SNA_PT_BCLONERS_2CFE5)
    bpy.utils.register_class(SNA_PT_EFFECTORS_B0489)
    bpy.utils.register_class(SNA_PT_OBJECT_TOOLS_B0D35)
    bpy.utils.register_class(SNA_PT_FIELDS_4D6BE)
    translate.register()


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_AddonPreferences_C2E71)
    bpy.utils.unregister_class(SNA_PT_BCLONERS_F7E3F)
    bpy.utils.unregister_class(SNA_PT_MATERIAL_TOOLS_25CAB)
    bpy.utils.unregister_class(SNA_PT_EFFECTORS_77735)
    bpy.utils.unregister_class(SNA_OT_Operator001_F8E6E)
    bpy.utils.unregister_class(SNA_OT_Operator_27876)
    bpy.utils.unregister_class(SNA_OT_Operator002_146A7)
    bpy.utils.unregister_class(SNA_PT_OBJECT_TOOLS_2D0E8)
    bpy.utils.unregister_class(SNA_OT_Operator003_88223)
    bpy.utils.unregister_class(SNA_PT_FIELDS_DB01C)
    bpy.utils.unregister_class(SNA_PT_MATERIAL_TOOLS_C6AC7)
    bpy.utils.unregister_class(SNA_PT_BCLONERS_2CFE5)
    bpy.utils.unregister_class(SNA_PT_EFFECTORS_B0489)
    bpy.utils.unregister_class(SNA_PT_OBJECT_TOOLS_B0D35)
    bpy.utils.unregister_class(SNA_PT_FIELDS_4D6BE)
    translate.unregister()
